VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "VB Read/Write a list sample"
   ClientHeight    =   4200
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7515
   LinkTopic       =   "Form1"
   ScaleHeight     =   4200
   ScaleWidth      =   7515
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frmMP3 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3315
      Left            =   120
      TabIndex        =   6
      Top             =   660
      Width           =   2595
      Begin VB.Image Image1 
         Height          =   3765
         Left            =   -600
         Picture         =   "PlayList.frx":0000
         Top             =   120
         Width           =   3150
      End
   End
   Begin VB.Frame fraControls 
      BackColor       =   &H80000000&
      Caption         =   " Sample List Features "
      ForeColor       =   &H00000000&
      Height          =   3135
      Left            =   2940
      TabIndex        =   1
      Top             =   780
      Width           =   4395
      Begin VB.TextBox txtItemToAdd 
         Height          =   315
         Left            =   360
         TabIndex        =   8
         Text            =   "txtItemToAdd"
         Top             =   2460
         Width           =   2115
      End
      Begin VB.CommandButton cmdAddItem 
         Caption         =   "cmdAddItem"
         Height          =   450
         Left            =   2700
         TabIndex        =   7
         Top             =   2400
         Width           =   1515
      End
      Begin VB.CommandButton cmdReadList 
         Caption         =   "cmdReadList"
         Height          =   450
         Left            =   2700
         TabIndex        =   5
         Top             =   300
         Width           =   1515
      End
      Begin VB.ListBox lstPlayList 
         Height          =   1425
         Left            =   360
         Sorted          =   -1  'True
         TabIndex        =   4
         Top             =   360
         Width           =   2115
      End
      Begin VB.CommandButton cmdRemoveItem 
         Caption         =   "cmdRemoveItem"
         Height          =   450
         Left            =   2700
         TabIndex        =   3
         Top             =   1380
         Width           =   1515
      End
      Begin VB.CommandButton cmdWriteList 
         Caption         =   "cmdWriteList"
         Height          =   450
         Left            =   2700
         TabIndex        =   2
         Top             =   840
         Width           =   1515
      End
      Begin VB.Line linDivide 
         BorderColor     =   &H00800000&
         X1              =   360
         X2              =   4140
         Y1              =   2040
         Y2              =   2040
      End
      Begin VB.Label lblAddItem 
         Caption         =   "Add an item to list"
         Height          =   195
         Left            =   120
         TabIndex        =   9
         Top             =   2160
         Width           =   1935
      End
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Mr. McCormack's, Play List Sample Tutorial"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   7275
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Application: Sample of a Play List - Read/Write a file
' version : Beta 1.01
' Authors : Mr. McCormack, P.Eng.
'           Professor Multimedia
'          Confederation College
'
' Prepared for MM 108, Fall 2001
' This is just a tutorial, but may have many uses
' including a Play List for an mp3 player,
' or for whenever you want a list for your VB project
' Note nice formatting of code and header

' Created: Nov 16, 2001
' Revised: Nov 22, 2001
'
' Copyright: Confederation College
' Use and distribute freely

' Reference:
' http://home12.inet.tele.dk/mkaratha/CreatePlaylist.htm
'
' email: rob@robmccormack.com
'
' Temp debug statement ???
'
' Bugs and ToDo list
' ----------------------------------
' Learning Objectives for MM 108
' 1- How to read/write a file into a ListBox
' 2- How to prevent error if file doesn't exist
' 3- How to call a function for Path to file
' 4- How to use a Global Variable for name of file
' 5- How to use Form Load and Unload to save
'    information, so user doesn't have to press buttons

' Since this Dim is in the
' General Declaraions, it can be used
' anywhere in this form
' use a small g to denote it is Global
' Notes, list is Sorted by the Property 'Sort"

Dim gFileName As String
Private Sub Form_Load()
'set the name of file to read/write
gFileName = GetMyPath & "playlist.txt"

'fill list by pressing the cmdReadList
cmdReadList_Click

End Sub

Private Sub Form_Unload(Cancel As Integer)

'save the list on Unload of Form
  cmdWriteList_Click
  
End Sub

Private Sub cmdAddItem_Click()
' Just add the item, trim off Right trailing spaces
lstPlayList.AddItem RTrim(txtItemToAdd.Text)

' Better write list to file
Open gFileName For Append As 1
  Print #1, txtItemToAdd.Text
Close 1

' now clear the text box
txtItemToAdd.Text = ""


End Sub

Private Sub cmdReadList_Click()

Dim IsFileThere As String
Dim tempString As String

' first, see if file exists,
' and prevent error if it doesn't
' Dir is a VB function that returns the full
' path to a file, if file doesn't exist,
' Dir returns a blank, ie. ""
 
 IsFileThere = Dir(gFileName)
 
 If IsFileThere = "" Then
   ' just exit this sub, don't cause trouble
   Exit Sub
 End If
 
' now clear the list, or your list will keep growing
' it willl Append the txt file to the existing list

lstPlayList.Clear


' OK, since the file does exist, read it in
Open gFileName For Input As 1
  While Not EOF(1)
    ' note that tempString just holds one line at a time
    Line Input #1, tempString
    lstPlayList.AddItem RTrim(tempString)
  Wend
Close 1


End Sub

Private Sub cmdRemoveItem_Click()

' These just report lstPlayList properties
' to help you write correct code

' MsgBox lstPlayList.Text
' MsgBox lstPlayList.ListIndex

'if no item is selected  ListIndex=-1,
'and we don't want to do anything

If lstPlayList.ListIndex >= 0 Then
  lstPlayList.RemoveItem (lstPlayList.ListIndex)
  ' it should display OK now, but we need
  ' to save the file as well
  cmdWriteList_Click
End If



End Sub

Private Sub cmdWriteList_Click()

Dim filename As String

' Use a function here to get path to file
filename = GetMyPath & gFileName

' No need for error trapping here
' writing a file will create one if it doesn't exist
' a$ is just a string variable, $ makes it so
' open the file for writing, and add List items
' one at a time by looping with a nice For Next loop

Open gFileName For Output As #1
  For i = 0 To lstPlayList.ListCount - 1
    a$ = lstPlayList.List(i)
    Print #1, a$
  Next
Close 1


End Sub

Public Function GetMyPath() As String
' This function will return the Path to the .exe
' and the text file is in the same Path

' Dimension the variable
Dim MyPath As String

' set MyPath to VB's App.Path
MyPath = Trim$(App.Path)

If Right$(MyPath, 1) = "\" Then
  GetMyPath = MyPath
Else
  GetMyPath = Trim$(MyPath) + "\"
End If

End Function

